/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

grammar gcode;

options {
    language = Java;
    // generated parser should create abstract syntax tree
    output = AST;
}


def 	:	statement+ fimprograma
	;
	
fimprograma 
	:	numerolinha mfim
	;
		
statement 
	:	numerolinha codfunc coordx coordy fimdelinha
        |       numerolinha codfunc coordx fimdelinha
        |       numerolinha codfunc coordy fimdelinha
	|	numerolinha mfunc fimdelinha
	|       fimdelinha
	;

numerolinha 
	:	'N'num3dig
	;

num3dig :       INT INT INT
        ;

mfim 	:	'M30'
	;
	
mfunc 
	:	'M02'
	|	'M01' STRING
	;
	
codfunc :	'G01'
	|	'G00'
	;
	
coordx 	:	'X'coord
	;

coordy 	:	 'Y'coord
	;
		
coord   :       INT INT? INT?
        ;

fimdelinha :	'\r\n'
	|	'\n'
	;
			
INT :	[0-9]
    ;
	
WS  : [ \t]+ -> skip ;

	
STRING  :  '"' ( ESC_SEQ | ~('\\'|'"') )* '"'
    ;

fragment
HEX_DIGIT : ('0'..'9'|'a'..'f'|'A'..'F') ;

fragment
ESC_SEQ
    :   '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\')
    |   UNICODE_ESC
    |   OCTAL_ESC
    ;

fragment
OCTAL_ESC
    :   '\\' ('0'..'3') ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7')
    ;

fragment
UNICODE_ESC
    :   '\\' 'u' HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
    ;


